package com.cweb.controller.pay;

import com.alibaba.fastjson.JSONObject;
import com.cweb.config.SysConst;
import com.hai.common.pay.WechatPayUtil;
import com.hai.common.pay.util.IOUtil;
import com.hai.common.pay.util.XmlUtil;
import com.hai.common.pay.util.sdk.WXPayConstants;
import com.hai.common.utils.HttpsUtils;
import com.hai.common.utils.ResponseMsgUtil;
import com.hai.common.utils.WxUtils;
import com.hai.entity.BsCompany;
import com.hai.entity.SecRegion;
import com.hai.model.ResponseData;
import com.hai.model.WxSharingOrderRequestModel;
import com.hai.model.WxSharingReceiversVO;
import com.hai.service.pay.NotifyService;
import com.hai.service.pay.PayRecordService;
import com.wechat.pay.contrib.apache.httpclient.util.PemUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import net.sf.cglib.beans.BeanMap;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.ssl.SSLContexts;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.net.ssl.SSLContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.security.*;
import java.util.*;

@Controller
@RequestMapping(value = "/wechatpay")
@Api(value = "微信支付")
public class WechatPayController {

    private static Logger log = LoggerFactory.getLogger(WechatPayController.class);

    private WXPayConstants.SignType signType;

    @Resource
    private NotifyService notifyService;
    @Resource
    private PayRecordService payRecordService;
    @Resource
    private WechatPayUtil wechatPayUtil;

    @RequestMapping(value = "/notify", method = RequestMethod.POST)
    @ApiOperation(value = "微信支付 -> 异步回调")
    public void wechatNotify(HttpServletRequest request, HttpServletResponse response) {
        try {
            log.info("微信支付 -> 异步通知：处理开始");

            String resXml = "";    // 反馈给微信服务器
            String notifyXml = null;    // 微信支付系统发送的数据（<![CDATA[product_001]]>格式）
            notifyXml = IOUtil.inputStreamToString(request.getInputStream(), "UTF-8");

            log.info("微信支付系统发送的数据：" + notifyXml);
            SortedMap<String, String> map = XmlUtil.parseXmlToTreeMap(notifyXml, "UTF-8");

            resXml = notifyService.wechatNotify(map);

/*            if (SignatureUtil.reCheckIsSignValidFromWeiXin(notifyXml, SysConst.getSysConfig().getWxApiKey(), "UTF-8")) {
                log.info("微信支付系统发送的数据：" + notifyXml);
                SortedMap<String, String> map = XmlUtil.parseXmlToTreeMap(notifyXml, "UTF-8");

                resXml = notifyService.wechatNotify(map);
            } else {
                log.error("微信支付 -> 异步通知：验签失败");
                log.error("apiKey：" + SysConst.getSysConfig().getWxApiKey());
                log.error("返回信息：" + notifyXml);
                resXml = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>"
                        + "<return_msg><![CDATA[签名验证错误]]></return_msg>" + "</xml> ";
            }*/

            BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());
            out.write(resXml.getBytes());
            out.flush();
            out.close();
            log.info("微信支付 -> 异步通知：处理完成");
        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }

    /*@RequestMapping(value = "/testCreateOrder", method = RequestMethod.GET)
    @ApiOperation(value = "微信测试 创建支付信息（发版时注释此接口）")
    @ResponseBody
    public SortedMap<Object, Object> testCreateOrder(@RequestParam(value = "subject", required = true) String subject,
                                                     @RequestParam(value = "orderNo", required = true) String orderNo,
                                                     @RequestParam(value = "totalPrice", required = true) Integer totalPrice,
                                                     HttpServletRequest httpRequest, HttpServletResponse httpResponse) {
        try {
            String nonce_str = MD5Util.MD5Encode(String.valueOf(ThreadLocalRandom.current().nextInt(10000)), "UTF-8");
            WeChatPayReqInfo weChatPayReqInfo = new WeChatPayReqInfo();
            weChatPayReqInfo.setAppid(wechatConfig.getApp_id());                                //公众号id
            weChatPayReqInfo.setMch_id(wechatConfig.getMch_id());                               //商户号
            weChatPayReqInfo.setNonce_str(nonce_str);                                           //随机字符串
            weChatPayReqInfo.setBody(subject);                                            //商品描述
            weChatPayReqInfo.setOut_trade_no(orderNo);                            //商户订单号
            weChatPayReqInfo.setTotal_fee(totalPrice);                                           //总
            weChatPayReqInfo.setSpbill_create_ip("182.43.154.4");                              //终端ip
            weChatPayReqInfo.setNotify_url(wechatConfig.getNotify_url());                       //通知url
            //weChatPayReqInfo.setTrade_type("APP");                                              //交易类型
            weChatPayReqInfo.setTrade_type("JSAPI");
            //weChatPayReqInfo.setOpenid("");
            weChatPayReqInfo.setAttach("Test");

            *//** 获取沙箱key start *//*
            String sandboxKey = GetSignKey();
            *//** 获取沙箱key end *//*
            String sign = SignatureUtil.createSign(weChatPayReqInfo, sandboxKey, "UTF-8");    // 测试 todo del
            weChatPayReqInfo.setSign(sign);
            String unifiedXmL = XmlUtil.toSplitXml(weChatPayReqInfo);

            String unifiedOrderResultXmL = HttpReqUtil.HttpsDefaultExecute("POST", wechatConfig.getUnified_order_url(), null, unifiedXmL, null);
            log.error("支付信息：" + unifiedOrderResultXmL);
            // 签名校验
            SortedMap<Object,Object> sortedMap = null;
            // 组装支付参数
            WechatCallBackInfo wechatCallBackInfo = XmlUtil.getObjectFromXML(unifiedOrderResultXmL, WechatCallBackInfo.class);
            Long timeStamp =  System.currentTimeMillis()/1000;
            sortedMap = new TreeMap<>();
            sortedMap.put("appid",wechatConfig.getApp_id());
            sortedMap.put("partnerid",wechatConfig.getMch_id());
            sortedMap.put("prepayid",wechatCallBackInfo.getPrepay_id());
            sortedMap.put("noncestr",wechatCallBackInfo.getNonce_str());
            sortedMap.put("timestamp",timeStamp);
            sortedMap.put("package","Sign=WXPay");
            String secondSign = SignatureUtil.createSign(sortedMap, wechatConfig.getApi_key(), "UTF-8");
            sortedMap.put("sign",secondSign);

            return sortedMap;
        } catch (Exception e) {
            log.error("AlipayTest -> createOrder：生成订单错误", e);
        }
        return null;
    }*/


    /**
     * @desc 获取沙箱key
     */
    /*public String GetSignKey() throws Exception {
        String nonce_str = WXPayUtil.generateNonceStr();    //生成随机字符
        Map<String, String> param = new HashMap<>();
        param.put("mch_id", wechatConfig.getMch_id());    //需要真实商户号
        param.put("nonce_str", nonce_str);    //随机字符
        String sign = WXPayUtil.generateSignature(param, wechatConfig.getApi_key(), WXPayConstants.SignType.MD5);    //通过SDK生成签名其中API_KEY为商户对应的真实密钥
        param.put("sign", sign);
        String xml = WXPayUtil.mapToXml(param);    //将map转换为xml格式
        String url = "https://api.mch.weixin.qq.com/sandboxnew/pay/getsignkey";    //沙箱密钥获取api
        String signKey = HttpUtil.post(url, xml);
        System.out.println("signkey+"+signKey);
        Map<String, String> param1 = new HashMap<String, String>();
        param1 = WXPayUtil.xmlToMap(signKey.toString());
        String key = param1.get("sandbox_signkey");
        return key;
    }*/


    @RequestMapping(value = "/wxProfitsharing", method = RequestMethod.GET)
    @ApiOperation(value = "微信分账")
    @ResponseBody
    public ResponseData wxProfitsharing() {
        try {
            Map<String,String> param = new LinkedHashMap<>();
            param.put("appid", "wx637bd6f7314daa46");
            param.put("mch_id", "1289663601");
            param.put("sub_mch_id" , "1609882817");
            param.put("transaction_id" , "4200001152202106091959467542");
            param.put("out_order_no" , "HF2021060901121681200");
            param.put("nonce_str" , WxUtils.makeNonStr());

            List<Map<String,Object>> receiversList = new ArrayList<>();
            Map<String,Object> receiversMap = new LinkedHashMap<>();
            receiversMap.put("type", "MERCHANT_ID");
            receiversMap.put("account", "1603942866");
            receiversMap.put("amount", 1);
            receiversMap.put("description", "分给1603942866商户");
            //receiversMap.put("name", "个体户黎杨珍");
            receiversList.add(receiversMap);
            param.put("receivers" , JSONObject.toJSONString(receiversList));

            String signStr = WxUtils.generateSignature(param, "Skufk5oi85wDFGl888i6wsRSTkdd5df5" , WXPayConstants.SignType.HMACSHA256);
            param.put("sign" , signStr);

            /*String certPath = "/path/to/apiclient_cert.p12";

            String post = getToken("POST", "/v3/pay/transactions/h5", JSONObject.toJSONString(param));

            Map<String,Object> header = new HashMap<>();
            header.put("Accept","application/json");
            header.put("Authorization", "WECHATPAY2-SHA256-RSA2048 " + post);*/

            //JSONObject object = HttpsUtils.doWxPost("https://api.mch.weixin.qq.com/secapi/pay/profitsharing", param, header);

            //String url = "https://api.mch.weixin.qq.com/secapi/pay/profitsharing";
           String xm = WxUtils.mapToXml(param);
           // String rest = String.valueOf(HttpsUtils.postData(url, xm));
            return ResponseMsgUtil.success(this.doRefundRequest(param.get("mch_id"),null, xm));
           // return ResponseMsgUtil.success(null);

        } catch (Exception e) {
            log.error("CmsContentController --> getCorporateAdvertising() error!", e);
            return ResponseMsgUtil.exception(e);
        }
    }

    //微信小程序读取双向证书
    private static CloseableHttpClient readCertificate(String mchId) throws Exception{
        /**
         * 注意PKCS12证书 是从微信商户平台-》账户设置-》 API安全 中下载的
         */
        KeyStore keyStore = KeyStore.getInstance("PKCS12");
        //P12文件目录 证书路径，这里需要你自己修改，linux下还是windows下的根路径
        FileInputStream instream = new FileInputStream("G:\\hurui-project/hai-parent/hai-cweb/src/main/resources/privatekey/1289663601_apiclient_cert.p12");
        try {
            keyStore.load(instream, "1289663601".toCharArray());//这里写密码..默认是你的MCHID
        } finally {
            instream.close();
        }
        SSLContext sslcontext = SSLContexts.custom().loadKeyMaterial(keyStore, "1289663601".toCharArray()).build();//这里也是写密码的
        SSLConnectionSocketFactory sslsf = new SSLConnectionSocketFactory(sslcontext, SSLConnectionSocketFactory.getDefaultHostnameVerifier());
        // Allow TLSv1 protocol only
        return HttpClients.custom().setSSLSocketFactory(sslsf).build();
    }

    public String doRefundRequest(String mchId, String url, String data) throws Exception {

        //小程序退款需要调用双向证书的认证
        CloseableHttpClient httpClient = readCertificate(mchId);
        try {
            HttpPost httpost = new HttpPost("https://api.mch.weixin.qq.com/secapi/pay/profitsharing"); // 设置响应头信息
            httpost.addHeader("Connection", "keep-alive");
            httpost.addHeader("Accept", "*/*");
            httpost.addHeader("Content-Type", "text/xml");
            httpost.addHeader("Host", "api.mch.weixin.qq.com");
            httpost.addHeader("X-Requested-With", "XMLHttpRequest");
            httpost.addHeader("Cache-Control", "max-age=0");
            httpost.addHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0) ");
            httpost.setEntity(new StringEntity(data, "UTF-8"));
            CloseableHttpResponse response = httpClient.execute(httpost);
            try {
                HttpEntity entity = response.getEntity();
                String jsonStr = EntityUtils.toString(response.getEntity(), "UTF-8");
                EntityUtils.consume(entity);
                return jsonStr;
            } finally {
                response.close();
            }
        } catch (Exception e){
            throw new RuntimeException(e);
        } finally {
            httpClient.close();
        }
    }

    @RequestMapping(value = "/addLedgerReceiver", method = RequestMethod.POST)
    @ApiOperation(value = "微信支付 -> 添加分账接收方")
    public void addLedgerReceiver(HttpServletRequest request, HttpServletResponse response) {
        try {

            WxSharingReceiversVO receiversVO = new WxSharingReceiversVO();
            receiversVO.setAccount("1603942866");
            receiversVO.setType("MERCHANT_ID");
            receiversVO.setName("重庆惠昕石化有限责任公司");
            receiversVO.setRelation_type("SERVICE_PROVIDER");

            Map<String , String> map = new HashMap<>();

            map.put("mch_id" , "1289663601");
            map.put("sub_mch_id" , "1609882817");
            map.put("appid" , "wx637bd6f7314daa46");
            map.put("nonce_str" , WxUtils.makeNonStr());
            map.put("sign_type" , "HMAC-SHA256");
            map.put("receiver" , JSONObject.toJSONString(receiversVO));

            String sign = WxUtils.generateSignature(map, "Skufk5oi85wDFGl888i6wsRSTkdd5df5" , WXPayConstants.SignType.HMACSHA256);

            map.put("sign" , sign);

            String url = "https://api.mch.weixin.qq.com/pay/profitsharingaddreceiver";
            String xm = WxUtils.mapToXml(map);
            String rest = String.valueOf(HttpsUtils.postData(url, xm));

            System.out.println(rest);
            log.info("微信支付 -> 添加分账接收方：处理开始");
        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }


    String getToken(String method, String url, String body) throws UnsupportedEncodingException, SignatureException, NoSuchAlgorithmException, InvalidKeyException, FileNotFoundException {

        long timeMillis = System.currentTimeMillis();
        String nonceStr = String.valueOf(timeMillis);
        long timestamp = System.currentTimeMillis() / 1000;
        String message = buildMessage(method, url, timestamp, nonceStr, body);
        PrivateKey privateKey = PemUtil.loadPrivateKey(new FileInputStream("G:/hurui-project/hai-parent/hai-cweb/src/main/resources/privatekey/apiclient_key.pem"));
        String signature = sign(privateKey,message.getBytes("utf-8"));

        return "mchid=\"" + SysConst.getSysConfig().getWxSubMchId() + "\","
                + "nonce_str=\"" + nonceStr + "\","
                + "timestamp=\"" + timestamp + "\","
                + "serial_no=\"" + "1B08DC2A078B0B1F77A65C97C445AAD545B5EAA6" + "\","
                + "signature=\"" + signature + "\"";
    }

    String sign(PrivateKey privateKey,byte[] message) throws SignatureException, NoSuchAlgorithmException, InvalidKeyException {
        Signature sign = Signature.getInstance("SHA256withRSA");
        sign.initSign(privateKey);
        sign.update(message);
        return Base64.getEncoder().encodeToString(sign.sign());
    }

    String buildMessage(String method, String url, long timestamp, String nonceStr, String body) {
        return method + "\n"
                + url + "\n"
                + timestamp + "\n"
                + nonceStr + "\n"
                + body + "\n";
    }



}
